package com.bastionsdk.ane.android;

import java.util.HashMap;
import java.util.Map;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.bastionsdk.ane.android.functions.RedeemCodeFunction;
import com.bastionsdk.ane.android.functions.RestoreFunction;
import com.bastionsdk.ane.android.functions.SetCanUseAdvertisingIDFunction;
import com.bastionsdk.ane.android.functions.SetCanUseAndroidIDFunction;
import com.bastionsdk.ane.android.functions.SetCanUseIDFAFunction;
import com.bastionsdk.ane.android.functions.SetCustomUserIDFunction;
import com.bastionsdk.ane.android.functions.StartFunction;
import com.bastionsdk.ane.android.functions.StopFunction;

public class ExtensionContext extends FREContext
{

	@Override
	public void dispose()
	{
		// TODO Auto-generated method stub

	}

	@Override
	public Map<String, FREFunction> getFunctions()
	{
		Map<String, FREFunction> functions = new HashMap<String, FREFunction>();
		
		functions.put("start", 						new StartFunction());
		functions.put("stop", 						new StopFunction());
		functions.put("redeemCode", 				new RedeemCodeFunction());
		functions.put("restore", 					new RestoreFunction());
		functions.put("setCustomUserID", 			new SetCustomUserIDFunction());
		functions.put("setCanUseAndroidID", 		new SetCanUseAndroidIDFunction());
		functions.put("setCanUseAdvertisingID", 	new SetCanUseAdvertisingIDFunction());
		functions.put("setCanUseIDFA", 				new SetCanUseIDFAFunction());
		
		return functions;
	}

}
