package com.bastionsdk.ane.android.functions;

import org.json.JSONObject;

import android.util.Log;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;
import com.bastionsdk.android.Bastion;
import com.bastionsdk.android.BastionCodeListener;
import com.bastionsdk.android.CodeErrorInfo;
import com.bastionsdk.android.FailReason;
import com.bastionsdk.android.Offer;
import com.bastionsdk.ane.android.helpers.JSONMapper;

public class RedeemCodeFunction implements FREFunction
{

	@Override
	public FREObject call(final FREContext context, FREObject[] args)
	{
		String code = null;
		
		try
		{
			code = args[0].getAsString();
		}
		catch(Exception e)
		{
			Log.e("BastionANE", "Error on retreiving code");
		}
		
		Bastion.redeemCode(code, new BastionCodeListener()
		{
			@Override
			public void onRedeemCodeSuccess(String code, Offer offer)
			{
				Log.d("BastionANE", "Promocode redeeemed : "+offer.getOfferReference());
				
				try
				{
					JSONObject response = new JSONObject();
					response.put("code", code);
					response.put("offer", JSONMapper.toJSON(offer));
					
					context.dispatchStatusEventAsync(response.toString(), "onRedeemCodeSuccess");
				}
				catch (Exception e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			
			@Override
			public void onRedeemCodeFailed(String code, FailReason reason, CodeErrorInfo infos)
			{
				Log.d("BastionANE", "Promocode failed : "+reason.toString());
				
				try
				{
					JSONObject response = new JSONObject();
					response.put("code", code);
					response.put("reason", reason.toString());
					
					if( infos != null )
					{
						response.put("infos", JSONMapper.toJSON(infos));
					}
					
					context.dispatchStatusEventAsync(response.toString(), "onRedeemCodeFailed");
				}
				catch (Exception e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
		
		return null;
	}

}
