package com.bastionsdk.ane.android.functions;

import java.util.List;

import org.json.JSONObject;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;
import com.bastionsdk.android.Bastion;
import com.bastionsdk.android.BastionRestoreListener;
import com.bastionsdk.android.FailReason;
import com.bastionsdk.android.Feature;
import com.bastionsdk.android.Resource;
import com.bastionsdk.ane.android.helpers.JSONMapper;

public class RestoreFunction implements FREFunction
{

	@Override
	public FREObject call(final FREContext context, FREObject[] args)
	{
		Bastion.restore(new BastionRestoreListener()
		{
			
			@Override
			public void onRestoreSucceed(List<Feature> features, List<Resource> resources)
			{
				try
				{
					JSONObject response = new JSONObject();
					
					response.put("feat", JSONMapper.featuresToJSON(features));
					response.put("res", JSONMapper.resourcesToJSON(resources));
					
					context.dispatchStatusEventAsync(response.toString(), "onRestoreSucceed");
				}
				catch(Exception e)
				{
					//TODO
					e.printStackTrace();
				}
			}
			
			@Override
			public void onRestoreFailed(FailReason reason)
			{
				context.dispatchStatusEventAsync(reason.toString(), "onRestoreFailed");
			}
		});
		
		return null;
	}

}
