package com.bastionsdk.ane.android.functions;

import android.util.Log;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;
import com.bastionsdk.android.Bastion;
import com.bastionsdk.android.BastionOfferListener;
import com.bastionsdk.android.Offer;
import com.bastionsdk.ane.android.helpers.JSONMapper;

public class StartFunction implements FREFunction
{

	@Override
	public FREObject call(final FREContext context, FREObject[] args)
	{		
		String apikey = null;
		
		try
		{
			apikey = args[0].getAsString();
		}
		catch(Exception e)
		{
			Log.e("BastionANE", "Error on retreiving api key");
		}
		
		Bastion.onStart(apikey, context.getActivity(), new BastionOfferListener()
		{
			@Override
			public void onRedeemOffer(Offer offer)
			{
				Log.d("BastionANE", "Offer redeeemed : "+offer.getOfferReference());
				try
				{
					String offerJson = JSONMapper.toJSON(offer).toString();
					Log.d("BastionANE", "Offer details : "+offerJson);
					
					context.dispatchStatusEventAsync(offerJson, "onRedeemOffer");
				}
				catch (Exception e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
		
		return null;
	}

}
